<template>
  <div class="header-wrapper" v-click-outside="closeSideBar">
    <header class="app-header-01 app-header navbar">
      <div class="navbar-brand">
        <router-link to="/">
          <div class="navbar-brand-full">
            <img :src="`${$baseUrl}/images/hetachain_headerlogo.png`" alt="logo">
          </div>
        </router-link>
      </div>

      <div class="trigger-mobile" :class="{'active': isShowSideBar}" @click="toggleSideBar">
        <span></span>
      </div>
    </header>

    <div class="sidebar-01 sidebar" :class="{'show': isShowSideBar}">
      <div class="sidebar-content">
        <ul class="nav">
          <template v-for="(item, navItem) in menuList">
            <li class="nav-item" v-if="item.isAuthenticated === undefined || item.isAuthenticated" :class="{'active': item.isShowSubmenu || isActiveSubmenu(navItem)} || isPageActive()">
              <div v-if="item.submenu" class="sub-menu-wrapper" :class="{'active': item.isShowSubmenu}" @click="toggleSubmenu(navItem)">
                <span class="nav-link">{{ $t(item.text) }}</span>
                <i class="fa fa-caret-down arrow" aria-hidden="true"></i>
                <div class="sup-effect">
                  <ul class="sub-menu">
                    <router-link
                      v-for="(sub, index) in item.submenu"
                      class="nav-link"
                      :class="{'active': isPageActive(sub.path)}"
                      :key="index"
                      :to="sub.path"
                      v-if="item.isAuthenticated"
                      @click.native="closeSideBar">
                      {{ $t(sub.text) }}
                    </router-link>
                  </ul>
                </div>
              </div>

              <router-link v-else
                           class="nav-link"
                           :to="{ name: item.name}"
                           @click.native="closeSideBar">
                {{ $t(item.text) }}
              </router-link>
            </li>
          </template>
        </ul>

        <div class="user" v-if="$isAuthenticated">
          <p class="user__email">{{ user.email }}</p>
          <p class="user__infor-item">
            Heta Token:
            <span class="user__heta-value">{{ hetaTokensWallet.balance | formatCurrencyAmount('heta', '0') }}</span>
          </p>
          <div class="user__infor-item">
            <router-link to="/users/profileSetting" class="user-link" @click.native="closeSideBar">
              {{ $t('header.txt8') }}
            </router-link>
          </div>
          <div class="user__infor-item">
            <router-link to="/users/kyc" class="user-link" @click.native="closeSideBar">
              {{ $t('header.txt9') }}
              <span class="kyc_status" :class="kycStatus">{{ kycStatus }}</span>
            </router-link>
          </div>
          <div class="user__infor-item" @click="$refs.logoutForm.submit()">
            {{ $t('header.logout') }} <span class="iconmo-export"></span>
          </div>
          <form :action="`${$baseUrl}/logout`" ref="logoutForm" style="display: none" method="post">
            <input type="hidden" name="_token" :value="$csrfToken">
          </form>
        </div>

        <ul class="language-list">
          <li class="list-item"
              v-for="locale in supportedLocales"
              :class="{active: $i18n.locale === locale}"
              @click="updateUserLocale(locale)">
            {{ locale | uppercase }}
          </li>
        </ul>
      </div>
    </div>
  </div>
</template>
<script>
  import rf from '../../../common/requests/RequestFactory';
  import Utils from '../../../common/utils';
  import { mapState, mapGetters } from 'vuex';

  export default {
    data () {
      return {
        isShowSideBar: false,
        isShowProfile: false,
        listKycStatus: ['unverified', 'pending', 'verified', 'rejected'],
        menuList: [
          {
            name: 'Dashboard',
            text: 'header.txt1',
            isAuthenticated: this.$isAuthenticated,
          },
          {
            name: 'Funds',
            text: 'header.txt2',
            isAuthenticated: this.$isAuthenticated,
            submenu: [
              {
                name: "Balance",
                text: 'header.txt3',
                path: "balances",
                isAuthenticated: this.$isAuthenticated,
              },
              {
                name: "Deposit",
                text: 'header.txt4',
                path: "deposit",
                isAuthenticated: this.$isAuthenticated,
              },
              {
                name: "Transactions",
                text: 'header.txt5',
                path: "wallet/transactions",
                isAuthenticated: this.$isAuthenticated,
              },
              {
                name: "Toekn History",
                text: 'header.txt10',
                path: "token-history",
                isAuthenticated: this.$isAuthenticated,
              }
            ],
            isShowSubmenu: false,
          },
          {
            name: 'Bounty & Airdrop',
            text: 'header.txt6',
            isAuthenticated: this.$isAuthenticated,
          },
          {
            name: 'FAQ',
            text: 'header.txt7',
          },
          {
            name: 'Guide',
            text: 'header.txt11',
          },
        ],
      }
    },
    computed: {
      ...mapGetters(['hetaTokensWallet']),
      ...mapState([
        'user',
        'supportedLocales',
      ]),
      kycStatus() {
        if (!this.listKycStatus[this.user.kyc_status]) {
          return '';
        }

        return this.listKycStatus[this.user.kyc_status];
      }
    },
    methods: {
      toggleSideBar () {
        this.isShowSideBar = !this.isShowSideBar;
        this.$broadcast('toggleSideBar');
      },

      toggleSubmenu(index) {
        this.menuList[index].isShowSubmenu = !this.menuList[index].isShowSubmenu;
      },

      closeSideBar () {
        if (this.isShowSideBar) {
          this.toggleSideBar();
        }
      },

      isPageActive(routeName) {
        const reg = new RegExp(`/${routeName}`);
        return reg.test(this.$route.path);
      },

      isActiveSubmenu(index) {
        let check = false;

        if (this.menuList[index].submenu) {
          this.menuList[index].submenu.map(e=>{
            if (this.isPageActive(e.path)) {
              check =  true;
            }
          })
        }
        return check;
      },

      updateUserLocale(locale){
        Utils.setI18nLocale(locale);
        document.documentElement.setAttribute('lang', locale);

        let params = {
          lang: locale
        };
        rf.getRequest('UserRequest').setLocale(params);
      },
    },
  }
</script>
<style scoped lang="scss">
  @import '../../../../sass/mobile/app.scss';
  $orangeBold: #fa7300;

  .navbar-brand img {
    max-width: 122rem;
  }

  .header-wrapper {
    transition: all 0.3s ease-in-out;

    &.show {
      transform: translateX(-240rem);
    }
  }

  // mobile css
  .app-header-01 {
    height: 60rem;
    border-bottom: 1rem solid transparent;
    background-image: linear-gradient(to bottom, #191332, #1a1536);
  }

  .trigger-mobile {
    width: 26rem;
    height: 16rem;
    position: absolute;
    top: 50%;
    right: 15rem;
    -webkit-transform: translateY(-50%);
    -ms-transform: translateY(-50%);
    transform: translateY(-50%);

    span {
      position: absolute;
      top: 50%;
      transform: translateY(-50%);
      display: inline-block;
      height: 2rem;
      width: 100%;
      background-color: #fff;
      transition: all 0.3s ease-in-out;
    }

    &:before,
    &:after {
      content: '';
      display: inline-block;
      width: 100%;
      height: 2rem;
      background-color: #fff;
      top: 0;
      left: 0;
      position: absolute;
      transition: all 0.3s ease-in-out;
    }

    &:after {
      top: auto;
      bottom: 0;
    }

    &.active {
      span {
        margin-left: 20rem;
        opacity: 0;
      }

      &:before {
        top: 5rem;
        transform: rotateZ(135deg) translateX(1px);
      }

      &:after {
        transform: rotateZ(-135deg) translateX(1px);
        bottom: 7rem;
      }
    }
  }

  .sidebar-01 {
    background-color: #2f353a;
    bottom: 0;
    right: 0;
    left: 0;
    top: 60rem;
    position: fixed;
    /*height: calc(100vh - 60rem);*/
    margin-left: 0 !important;
    transition: all 0.3s ease-in-out;
    transform: translateX(100%);
    background-image: linear-gradient(to bottom, #1a1536, $catalina_blue);

    .nav {
      padding: 23rem 0 28rem;
      /*max-height: calc(100vh - 160rem);*/
      min-height: 200rem;
      overflow: auto;
    }

    .nav-item {
      width: 100%;
      margin-bottom: 9rem;

      .arrow {
        font-size: $tiny;
        color: #fff;
      }

      &.active .sub-menu-wrapper >.nav-link,
      &.active .sub-menu-wrapper >.arrow {
        color: $orangeBold;
      }
    }

    .nav-link {
      letter-spacing: -0.5rem;
      transition: all 0.3s ease-in-out;

      &.active {
        margin-bottom: 0;
      }
    }

    .sub-menu-wrapper {
      .nav-link {
        display: inline-block;
      }

      &.active {
        .sup-effect {
          max-height: 500rem;
        }
      }
    }

    .sup-effect {
      max-height: 0;
      overflow: hidden;
      transition: all 0.3s ease-in-out;
    }

    .sub-menu {
      margin-bottom: 18rem;
      padding-left: 40rem;
      .nav-link {
        display: block;
        color: #b0b0b0;
        font-size: $small;
        padding: 1rem 0;
      }
    }

    .nav-link {
      font-size: $medium;
      font-weight: bold;
      color: #ffffff;
      padding: 0 12rem;


      &.active {
        color: $orangeBold;
      }
    }

    &.show {
      transform: translateX(0);
    }
  }

  .sidebar-content {
    overflow: hidden;
    overflow-y: auto;
    height: 100%;
    position: relative;
  }

  .user {
    position: absolute;
    bottom: 45rem;
    width: 100%;
    left: 0;
    font-size: 14rem;
    color: #b0b0b0;
    padding: 27rem 12rem;
    background-color: #1c163e;
    @media screen and (min-width: 500px){
      position: relative;
      bottom: 20rem;
    }

    .user__email {
      font-size: $medium;
      color: $orangeBold;
      font-weight: bold;
      margin-bottom: 12rem;
      text-decoration: underline;
      letter-spacing: -0.5rem;
    }

    .user__infor-item {
      margin-bottom: 3rem;
      .inconmo-export {
        font-size: 12rem;
      }
    }

    .user-link {
      color: #b0b0b0;

      &.active {
        color: $orangeBold;
      }

      .kyc_status {
        color: #4a90e2;
        &.pending {
          color: #fcb202;
        }
        &.verified {
          color: #4caf50;
        }
        &.rejected {
          color: #d0021b;
        }
      }
    }

    .user__heta-value {
      color: #fff;
    }
  }

  .language-list {
    position: fixed;
    bottom: 0;
    left: 0;
    right: 0;
    font-size: 0;
    padding-left: 0;
    margin-bottom: 0rem;

    .list-item {
      width: 25%;
      font-size: $tiny;
      font-weight: bold;
      text-align: center;
      color: #b0b0b0;
      display: inline-block;
      padding: 13rem 30rem;
      background-color: $catalina_blue;
      transition: all 0.3s ease-in-out;

      &:not(:last-child) {
        border-right: 1rem solid #1c163e;
      }

      &.active {
        color: $orangeBold;
      }
    }
  }
</style>
